# This module only provides metainformation for configuration
# dialog to allow resource themes selection

package require resource

namespace eval meta {
	set name "Themes"
	set author "Ihar Viarheichyk <iverg@mail.ru>"
	set description "Select resource themes from configuration dialog"
	array set _ { type cache }
}

# Update metainformation
proc metarefresh {args} {
	set vars [map x [info vars meta::*] {namespace tail $x} ]
	foreach class [::resource::classes] {
		if {[set pos [lsearch $vars $class]]!=-1} {
			set vars [lreplace $vars $pos $pos]
		}
		if {[info exists meta::$class]} continue
		set name [namespace current]::$class	
		if {![info exists $name]} {
			set ${name} [resource::theme $class]
		} else { resource::theme $class [set $name]}
		set values [resource::themes $class]
		array set meta::$class [list type variant\
			values $values default [set $name]\
			empty "(default)"]
		trace variable ${name} w [nc Change]
	}
	foreach x $vars {
		if {![array exists meta::$x]} continue
		unset meta::$x
		set x [namespace current]::$x
		if {[info exists $x]} { unset $x }
	}
}

# Change theme if proper variable was changed
proc Change {name args} {
	upvar 1 $name value
	set name [namespace tail $name]
	resource::theme $name $value
	set module  [namespace tail [namespace current]]
	::Save [rcfile] "^ *$module +$name" [list $module $name $value]
}

# Alias configuration command to resource theme set command
interp alias {} [namespace tail [namespace current]] {} resource::theme

# Update metainformation on configuration file loaded and then after each
# new module loaded
hook ModuleLoaded [nc metarefresh]
hook ModuleUnloaded [nc metarefresh]
metarefresh
